
/*Context.c  
 *for handling popup menus
 */

#include "main.h"

void menu_open_new_tabc(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
	gchar *href;
	
	href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");
    create_container(mozzie);
	gtk_moz_embed_load_url(GTK_MOZ_EMBED
			       (mozzie->gd->geckoEmbed),
			       href);
	g_print("%s",href);
}


gboolean download_url2 (geckobrowser * mozzie, const gchar * uri)
{
 return TRUE;
}


gboolean download_url (geckobrowser * mozzie, const gchar * uri)
{
   open_uri_cb(mozzie->gd->geckoEmbed,uri,mozzie);
	g_print("CASIUS");
}

void
make_window_from_popup (GtkWidget * menuitem, geckobrowser * mozzie)
{
	gchar *href;
	geckobrowser *newBrowser =
		create_mozilla (GTK_MOZ_EMBED_FLAG_DEFAULTCHROME);
	gtk_widget_set_usize (newBrowser->gd->geckoEmbed, 700, 500);
	set_browser_visibility (newBrowser, TRUE);
	href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");
	gtk_moz_embed_load_url (GTK_MOZ_EMBED (newBrowser->gd->geckoEmbed),
				href);
}

void
browse_in_window_from_popup (GtkWidget * menuitem, geckobrowser * mozzie)
{
	gchar *href;

	href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");
	gtk_moz_embed_load_url (GTK_MOZ_EMBED (mozzie->gd->geckoEmbed), href);

}

void
download_link_from_popup (GtkWidget * menuitem, geckobrowser * mozzie)
{
    gchar *href;

    href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");
    download_url (mozzie, href);
}

void
save_image_from_popup (GtkWidget * menuitem, geckobrowser * mozzie)
{

	gchar *href, *name;

	href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");
	if (!href)
		return;
	name = gtk_object_get_data (GTK_OBJECT (menuitem), "name");
	save_image (mozzie, href, name);
	return;
}


void
copy_link_from_popup (GtkWidget * menuitem, geckobrowser * mozzie)
{
	gchar *href;
	gint have_selection;
	GtkWidget *window;
	gembed *hydra;
    
    g_print("hydra");
	hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	{
	 mozzie->gd = hydra;
	 g_print("Activado!");
	 window = mozzie->gd->geckoEmbed;
	}

	href = gtk_object_get_data (GTK_OBJECT (menuitem), "link");

	gtk_object_set_data (GTK_OBJECT (window),
			     "selection", g_strdup (href));
	have_selection = gtk_selection_owner_set (GTK_WIDGET (window),
					 gdk_atom_intern("CLIPBOARD",FALSE), 
					  GDK_CURRENT_TIME)&&
		         gtk_selection_owner_set (window,
					 GDK_SELECTION_PRIMARY,
					 GDK_CURRENT_TIME);
	g_print ("selection: %d", have_selection);
	if (!have_selection)
	{
		g_warning ("Selection not found");
	}
}



void
on_menu_destroy (GtkWidget * menu, gchar * name)
{
	gchar *free_href, *free_img, *free_linktext;
	free_href = gtk_object_get_data (GTK_OBJECT (menu), "freehref");
	if (free_href)
		g_free (free_href);
	free_img = gtk_object_get_data (GTK_OBJECT (menu), "freeimg");
	if (free_img)
		g_free (free_img);
	free_linktext =
		gtk_object_get_data (GTK_OBJECT (menu), "freelinktext");
	if (free_linktext)
		g_free (free_linktext);

}


GtkWidget *
get_link_popup_menu (geckobrowser * mozzie, gchar * href, gchar * linktext)
{
	GtkWidget *menu, *m1, *m2, *m3, *m4, *m5,*m6;

	if (mozzie->link_menu)
		gtk_widget_destroy (mozzie->link_menu);
	menu = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (menu), "freehref", href);
	gtk_object_set_data (GTK_OBJECT (menu), "freelinktext", linktext);
	/*gtk_signal_connect (GTK_OBJECT (menu), "destroy", on_menu_destroy,
			    "link menu");*/
	m1 = gtk_menu_item_new_with_label (_("Open In This Window.."));
	gtk_signal_connect (GTK_OBJECT (m1), "activate",
			    GTK_SIGNAL_FUNC (browse_in_window_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m1), "link", href);
	gtk_menu_append (GTK_MENU (menu), m1);
	m2 = gtk_menu_item_new_with_label (_("Open In A New Window..."));
	gtk_menu_append (GTK_MENU (menu), m2);
	gtk_object_set_data (GTK_OBJECT (m2), "link", href);
	gtk_signal_connect (GTK_OBJECT (m2), "activate",
			    GTK_SIGNAL_FUNC (make_window_from_popup), mozzie);
	
	m6 = gtk_menu_item_new_with_label (_("Open In A New Tab..."));
	gtk_menu_append (GTK_MENU (menu), m6);
	gtk_object_set_data (GTK_OBJECT (m6), "link", href);
	gtk_signal_connect (GTK_OBJECT (m6), "activate",
			    GTK_SIGNAL_FUNC (menu_open_new_tabc), mozzie);
	
    m3 = gtk_menu_item_new_with_label (_("Download File..."));
	gtk_signal_connect (GTK_OBJECT (m3), "activate",
			    GTK_SIGNAL_FUNC (download_link_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m3), "link", href);
	gtk_menu_append (GTK_MENU (menu), m3);
	m4 = gtk_menu_item_new_with_label (_("Copy Link Location..."));
	gtk_signal_connect (GTK_OBJECT (m4), "activate",
			    GTK_SIGNAL_FUNC (copy_link_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m4), "link", href);
	gtk_menu_append (GTK_MENU (menu), m4);
	m5 = gtk_menu_item_new_with_label (_("Add Bookmark For Link..."));
	gtk_object_set_data (GTK_OBJECT (m5), "link", href);
	gtk_object_set_data (GTK_OBJECT (m5), "linktext", linktext);
	gtk_signal_connect (GTK_OBJECT (m5), "activate",
			    GTK_SIGNAL_FUNC (linkbook), mozzie); 
	gtk_menu_append (GTK_MENU (menu), m5);
	gtk_widget_show_all (menu);
	mozzie->link_menu = menu;
	return menu;
}

GtkWidget *
get_image_popup_menu (geckobrowser * mozzie, gchar * img)
{
	GtkWidget *menu, *m1, *m2, *m3, *m4,*m5,*m6;
	gchar *lbl, *img_basename,*href;
    
	 
   if (mozzie->image_menu)
		gtk_widget_destroy (mozzie->image_menu);
	img_basename = g_basename (img);
	menu = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (menu), "freeimg", img);
	gtk_signal_connect (GTK_OBJECT (menu), "destroy", on_menu_destroy,
			    "image menu");
	m1 = gtk_menu_item_new_with_label (_("Open Image In This Window"));
	gtk_signal_connect (GTK_OBJECT (m1), "activate",
			    GTK_SIGNAL_FUNC (browse_in_window_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m1), "link", img);
	gtk_menu_append (GTK_MENU (menu), m1);
	m2 = gtk_menu_item_new_with_label (_("Open Image In A New Window"));
	gtk_menu_append (GTK_MENU (menu), m2);
	gtk_object_set_data (GTK_OBJECT (m2), "link", img);
	gtk_signal_connect (GTK_OBJECT (m2), "activate",
			    GTK_SIGNAL_FUNC (make_window_from_popup), mozzie);
				
	lbl = g_strdup_printf ("%s... (%s)", _("Save Image"), img_basename);
	m3 = gtk_menu_item_new_with_label (lbl);
	gtk_signal_connect (GTK_OBJECT (m3), "activate",
			    GTK_SIGNAL_FUNC (save_image_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m3), "link", img);
	gtk_object_set_data (GTK_OBJECT (m3), "name", img_basename);
	gtk_menu_append (GTK_MENU (menu), m3);
	m4 = gtk_menu_item_new_with_label (_("Copy Image Location"));
	gtk_signal_connect (GTK_OBJECT (m4), "activate",
			    GTK_SIGNAL_FUNC (copy_link_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m4), "link", img);
	gtk_menu_append (GTK_MENU (menu), m4);
	
	gtk_widget_show_all(menu);
	g_print("imagen2");
	g_free (lbl);
	mozzie->image_menu = menu;
	return menu;
}


GtkWidget *
get_doc_popup_menu (geckobrowser * mozzie, gchar * href)
{
	GtkWidget *menu, *m1;

	if (mozzie->doc_menu)
		gtk_widget_destroy (mozzie->doc_menu);
	menu = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (menu), "freehref", href);
	gtk_signal_connect (GTK_OBJECT (menu), "destroy", on_menu_destroy,
			    "doc menu");
	m1 = gtk_menu_item_new_with_label (_("Save Document"));
	gtk_signal_connect (GTK_OBJECT (m1), "activate",
			    GTK_SIGNAL_FUNC (savefile), mozzie);
	gtk_menu_append (GTK_MENU (menu), m1);
    gtk_widget_show_all (menu);
	mozzie->doc_menu = menu;
	return menu;

}

GtkWidget *
get_link_image_popup_menu (geckobrowser * mozzie, gchar * img, gchar * href)
{
	GtkWidget *menu, *m1, *m2, *m3, *m4, *sep, *m5, *m6, *m7, *m8,*m9;
	gchar *lbl, *img_basename;

	if (mozzie->image_link_menu)
		gtk_widget_destroy (mozzie->image_link_menu);
	img_basename = g_basename (img);
	menu = gtk_menu_new ();
	gtk_object_set_data (GTK_OBJECT (menu), "freehref", href);
	gtk_object_set_data (GTK_OBJECT (menu), "freeimg", img);
	gtk_signal_connect (GTK_OBJECT (menu), "destroy", on_menu_destroy,
			    "link image menu");
	m1 = gtk_menu_item_new_with_label (_("Open Image In This Window"));
	gtk_signal_connect (GTK_OBJECT (m1), "activate",
			    GTK_SIGNAL_FUNC (browse_in_window_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m1), "link", img);
	gtk_menu_append (GTK_MENU (menu), m1);

	m2 = gtk_menu_item_new_with_label (_("Open Image In A New Window"));
	gtk_menu_append (GTK_MENU (menu), m2);
	gtk_object_set_data (GTK_OBJECT (m2), "link", img);
	gtk_signal_connect (GTK_OBJECT (m2), "activate",
			    GTK_SIGNAL_FUNC (make_window_from_popup), mozzie);

	lbl = g_strdup_printf ("%s... (%s)", _("Save Image"), img_basename);
	m3 = gtk_menu_item_new_with_label (lbl);
	gtk_signal_connect (GTK_OBJECT (m3), "activate",
			    GTK_SIGNAL_FUNC (save_image_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m3), "link", img);
	gtk_object_set_data (GTK_OBJECT (m3), "name", img_basename);
	gtk_menu_append (GTK_MENU (menu), m3);

	m4 = gtk_menu_item_new_with_label (_("Copy Image Location"));
	gtk_signal_connect (GTK_OBJECT (m4), "activate",
			    GTK_SIGNAL_FUNC (copy_link_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m4), "link", img);
	gtk_menu_append (GTK_MENU (menu), m4);

	sep = gtk_menu_item_new ();
	gtk_menu_append (GTK_MENU (menu), sep);

	m5 = gtk_menu_item_new_with_label (_("Open In This Window"));
	gtk_signal_connect (GTK_OBJECT (m5), "activate",
			    GTK_SIGNAL_FUNC (browse_in_window_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m5), "link", href);
	gtk_menu_append (GTK_MENU (menu), m5);

	m6 = gtk_menu_item_new_with_label (_("Open In A New Window"));
	gtk_menu_append (GTK_MENU (menu), m6);
	gtk_object_set_data (GTK_OBJECT (m6), "link", href);
	gtk_signal_connect (GTK_OBJECT (m6), "activate",
			    GTK_SIGNAL_FUNC (make_window_from_popup), mozzie);

	m7 = gtk_menu_item_new_with_label (_("Download File"));
	gtk_signal_connect (GTK_OBJECT (m7), "activate",
			    GTK_SIGNAL_FUNC (download_link_from_popup),
			    mozzie);
	gtk_object_set_data (GTK_OBJECT (m7), "link", href);
	gtk_menu_append (GTK_MENU (menu), m7);

	m8 = gtk_menu_item_new_with_label (_("Copy Link Location"));
	gtk_signal_connect (GTK_OBJECT (m8), "activate",
			    GTK_SIGNAL_FUNC (copy_link_from_popup), mozzie);
	gtk_object_set_data (GTK_OBJECT (m8), "link", href);
	gtk_menu_append (GTK_MENU (menu), m8);
	
	m9 = gtk_menu_item_new_with_label (_("Open In A New Tab..."));
	gtk_menu_append (GTK_MENU (menu), m9);
	gtk_object_set_data (GTK_OBJECT (m9), "link", href);
	gtk_signal_connect (GTK_OBJECT (m9), "activate",
			    GTK_SIGNAL_FUNC (menu_open_new_tabc), mozzie);

	gtk_widget_show_all (menu);
	mozzie->image_link_menu = menu;
	return menu;
}
