
#include"main.h"
/*#include<libgnomeui/gnome-window-icon.h>*/
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>


gchar *home = NULL;
GList *browser_list;
GSList *window_count = NULL;
int num_browsers = 0;
int num_embeds = 0;
GList *bookmarks = NULL;
#define DEST_IP "200.11.52.1"
#define DEST_PORT 80
#define MAXDATASIZE 100

GdkColor mozpop = { 0, 0x0001, 0x9797, 0xCACA };

typedef enum
{
	STRING,
	COMPOUND_TEXT
} SelType;

/* selection types */
const GtkTargetEntry selection_types[] =
{
	{ "STRING",        0, STRING        },
	{ "COMPOUND_TEXT", 0, COMPOUND_TEXT }
};
const gint selection_types_num_targets = (sizeof (selection_types) /
					  sizeof (GtkTargetEntry));


/* XPM */
static char *small_close[] = {
    "8 9 17 1",
    " 	c None",
    ".	c #020302",
    "+	c #22262A",
    "@	c #626466",
    "#	c #828486",
    "$	c #A6A2AE",
    "%	c #AEAAB6",
    "&	c #B6B2BE",
    "*	c #BEBAC6",
    "=	c #EEEEF2",
    "-	c #424242",
    ";	c #121212",
    ">	c #4E5052",
    ",	c #FEFEFE",
    "'	c #72767A",
    ")	c #6A6E72",
    "!	c #1A1A1A",
    "        ",
    " &  *%  ",
    " >#=+;$ ",
    "  .>.@  ",
    "  @.-   ",
    "  -..'  ",
    " &;#!.) ",
    " >$ %;> ",
    "        "
};

void
window_selection_get_cb (GtkWidget *widget, GtkSelectionData *selection_data,
			 guint info, guint time_stamp, gpointer data)
{
	gchar *text;

	text = gtk_object_get_data (GTK_OBJECT(widget), "selection");

	gtk_selection_data_set (selection_data, GDK_SELECTION_TYPE_STRING,
				8, text, strlen (text));
	g_free(text);
}

void
window_set_selection_signals (geckobrowser *mozzie)
{
 
 /* set selection signal */
	gtk_selection_add_targets (GTK_WIDGET(mozzie->gd->geckoEmbed),
				   GDK_SELECTION_PRIMARY, 
				   selection_types, 
				   selection_types_num_targets);
	gtk_selection_add_targets (GTK_WIDGET(mozzie->gd->geckoEmbed),
				   gdk_atom_intern("CLIPBOARD", FALSE),
				   selection_types, 
				   selection_types_num_targets);
	gtk_signal_connect (GTK_OBJECT(mozzie->gd->geckoEmbed), "selection_get",
			    GTK_SIGNAL_FUNC (window_selection_get_cb),
			    NULL);
}


void offline()
{

    /*mozilla_set_offline(TRUE);*/
}

void advice()
{
    /*gchar message[] =
	"Salamander has detected that your Computer is\n"
	"not connected to the internet right now.Please\n"
	"connect to it before browsing the web with Salamander.\n\n"
	"This message will only appear when your Computer is not connected";

    gnome_ok_dialog(message);*/
}

void analyzenet()
{
    int sockfd;

    struct sockaddr_in dest_addr;

    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    dest_addr.sin_family = AF_INET;
    dest_addr.sin_port = htons(DEST_PORT);
    dest_addr.sin_addr.s_addr = inet_addr(DEST_IP);
    memset(&(dest_addr.sin_zero), '\0', 8);

    if (connect
	(sockfd, (struct sockaddr *) &dest_addr,
	 sizeof(struct sockaddr)) == -1) {
	perror("connect");
	advice();
    } else {
	printf("Network Status:OK");
    }
    close(sockfd);
}

void destroy_brsr_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);
    if (hydra) {
	mozzie->gd = hydra;
	g_print("Activado!");
    }
    g_print("destroy_brsr_cb\n");
    gtk_widget_destroy(GTK_WIDGET(mozzie->window));
    num_browsers--;
    /*num_embeds--; */
}

gboolean
delete_cb(GtkWidget * widget, GdkEventAny * event, geckobrowser * mozzie)
{
    g_print("delete_cb\n");
    if (num_browsers > 1) {
	load_finished_cb(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed), mozzie);
	gtk_widget_destroy(widget);
	num_browsers--;
	g_print("%d", num_browsers);
    } else
	gtk_main_quit();
    return TRUE;
}

void menu_open_new_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{

    geckobrowser *newBrowser =
	create_mozilla(GTK_MOZ_EMBED_FLAG_DEFAULTCHROME);
    gtk_widget_set_usize(newBrowser->gd->geckoEmbed, 300, 400);
    set_browser_visibility(newBrowser, TRUE);
}

void menu_quit_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    if (num_browsers > 1) {
	browser_list = g_list_remove(browser_list, (gpointer) mozzie);
	gtk_widget_destroy(mozzie->window);
	g_free(mozzie);
	num_browsers--;
    } else
	gtk_main_quit();
}

void set_browser_visibility(geckobrowser * mozzie, gboolean visibility)
{
    if (!visibility) {
	gtk_widget_hide(mozzie->window);
	return;
    }

    if (mozzie->menuBarOn)
	gtk_widget_show_all(mozzie->menubar);
    else
	gtk_widget_hide_all(mozzie->menubar);

    if (mozzie->toolBarOn || mozzie->locationBarOn)
	gtk_widget_show_all(mozzie->hbox);
    else
	gtk_widget_hide_all(mozzie->hbox);

    if (mozzie->statusBarOn)
	gtk_widget_show_all(mozzie->progressAreaHBox);
    else
	gtk_widget_hide_all(mozzie->progressAreaHBox);

    gtk_widget_show(mozzie->gd->geckobox);
    gtk_widget_show(mozzie->notebook);
    gtk_widget_show(mozzie->vbox);

    gtk_widget_show(mozzie->window);

}

void close_window(GtkWidget * button, gembed * gd)
{
    gtk_moz_embed_stop_load(GTK_MOZ_EMBED(gd->geckoEmbed));
    gtk_widget_hide(GTK_WIDGET(gd->geckobox));
    gtk_widget_destroy(GTK_WIDGET(gd->geckobox));

    g_print("borrado!");
    num_embeds--;

    g_print("%d", num_embeds);
}

GtkWidget *make_notebook_tab_widgeti(geckobrowser * mozzie)
{
    GtkWidget *hbox, *pixmap;
    GdkPixmap *gdkpixmap;
    GdkBitmap *mask;

	hbox = gtk_hbox_new(0, 0);

    mozzie->gd->geckobutton = gtk_button_new();
    gtk_button_set_relief((GtkButton *) mozzie->gd->geckobutton,
			  GTK_RELIEF_NONE);

    gdkpixmap =
	gdk_pixmap_colormap_create_from_xpm_d(mozzie->window->window,
					      gtk_widget_get_colormap
					      (hbox), &mask, NULL,
					      small_close);
    pixmap = gtk_pixmap_new(gdkpixmap, mask);
    gdk_pixmap_unref(gdkpixmap);
    gdk_bitmap_unref(mask);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckobutton), "clicked",
		       GTK_SIGNAL_FUNC(close_window), mozzie->gd);
    gtk_container_add(GTK_CONTAINER(mozzie->gd->geckobutton), pixmap);
    gtk_box_pack_start(GTK_BOX(hbox), mozzie->gd->notelabel, TRUE, TRUE,
		       2);
    gtk_box_pack_start(GTK_BOX(hbox), mozzie->gd->geckobutton, FALSE,
		       FALSE, 2);
	gtk_widget_set_sensitive(GTK_WIDGET(mozzie->gd->geckobutton),FALSE);
    gtk_widget_show_all(hbox);
    return hbox;
}

GtkWidget *make_notebook_tab_widget(geckobrowser * mozzie)
{
    GtkWidget *hbox, *pixmap;
    GdkPixmap *gdkpixmap;
    GdkBitmap *mask;

	hbox = gtk_hbox_new(0, 0);

    mozzie->gd->geckobutton = gtk_button_new();
    gtk_button_set_relief((GtkButton *) mozzie->gd->geckobutton,
			  GTK_RELIEF_NONE);

    gdkpixmap =
	gdk_pixmap_colormap_create_from_xpm_d(mozzie->window->window,
					      gtk_widget_get_colormap
					      (hbox), &mask, NULL,
					      small_close);
    pixmap = gtk_pixmap_new(gdkpixmap, mask);
    gdk_pixmap_unref(gdkpixmap);
    gdk_bitmap_unref(mask);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckobutton), "clicked",
		       GTK_SIGNAL_FUNC(close_window), mozzie->gd);
    gtk_container_add(GTK_CONTAINER(mozzie->gd->geckobutton), pixmap);
    gtk_box_pack_start(GTK_BOX(hbox), mozzie->gd->notelabel, TRUE, TRUE,
		       2);
    gtk_box_pack_start(GTK_BOX(hbox), mozzie->gd->geckobutton, FALSE,
		       FALSE, 2);
    gtk_widget_show_all(hbox);
    return hbox;
}

void update_tab_size(geckobrowser *mozzie)
{
    GtkWidget *tab;

    tab = mozzie->gd->geckobox;
    gtk_widget_set_usize(GTK_WIDGET(tab), -1, -1);
}

void window_add_embed(geckobrowser * mozzie)
{
    if (mozzie->notebook != NULL) {

	num_embeds =
	    gtk_notebook_current_page(GTK_NOTEBOOK(mozzie->notebook));
	g_print("%d", num_embeds);
	if (num_embeds == -1) {
	   /* mozzie->gd->notelabel = gtk_label_new("Salamander");*/
	    gtk_notebook_insert_page(GTK_NOTEBOOK(mozzie->notebook),
				     GTK_WIDGET(mozzie->gd->geckobox),
				     make_notebook_tab_widgeti(mozzie),
				     num_embeds + 2);
	    gtk_widget_show(GTK_WIDGET(mozzie->gd->notelabel));
		

	} else {
	   
        /*gtk_label_set_text(GTK_LABEL(mozzie->gd->notelabel),"Document");*/
	    gtk_notebook_insert_page(GTK_NOTEBOOK(mozzie->notebook),
				     GTK_WIDGET(mozzie->gd->geckobox),
				     make_notebook_tab_widget(mozzie),
				     num_embeds + 1);
	    update_tab_size(mozzie);
	    gtk_widget_show(GTK_WIDGET(mozzie->gd->notelabel));
        num_embeds++;
	         }
    }
  
	gtk_widget_show(mozzie->gd->geckoEmbed);
    gtk_widget_show(mozzie->gd->geckobox);
    gtk_notebook_set_page(GTK_NOTEBOOK(mozzie->notebook), num_embeds);

    g_print("Number of embeds : %d", num_embeds);
    if (num_embeds > -1) {
	gtk_entry_set_text(GTK_ENTRY(mozzie->urlEntry), "Document");
	
    }
}

void create_container(geckobrowser * mozzie)
{
    mozzie->gd = NULL;
	mozzie->gd = g_new0(gembed, 1);

    g_print("hola");

    mozzie->gd->geckourl = "Document";
    mozzie->gd->geckobox = gtk_vbox_new(FALSE, 0);
    mozzie->gd->geckoEmbed = gtk_moz_embed_new();
	mozzie->gd->notelabel = gtk_label_new("Document");
    gtk_box_pack_start(GTK_BOX(mozzie->gd->geckobox),
		       GTK_WIDGET(mozzie->gd->geckoEmbed), TRUE, TRUE, 0);
    gtk_object_set_data(GTK_OBJECT(mozzie->gd->geckobox),
			"SalamanderEmbed", mozzie->gd);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckobox), "destroy",
		       GTK_SIGNAL_FUNC(NULL), mozzie);
    gtk_widget_ref(GTK_WIDGET(mozzie->gd->geckoEmbed));
    gtk_object_set_data_full(GTK_OBJECT(mozzie->gd->geckoEmbed),
			     "Embed",
			     GTK_WIDGET(mozzie->gd->geckoEmbed),
			     (GtkDestroyNotify) gtk_widget_unref);
    g_print("concha2");
    window_add_embed(mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "net_start",
		       GTK_SIGNAL_FUNC(load_started_cb), mozzie);
	
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "link_message",
		       GTK_SIGNAL_FUNC(link_message_cb), mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "title",
		       GTK_SIGNAL_FUNC(title_changed_cb), mozzie);
 
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "location",
		       GTK_SIGNAL_FUNC(location_changed_cb), mozzie);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "net_stop",
		       GTK_SIGNAL_FUNC(load_finished_cb), mozzie);
	
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "new_window",
		       GTK_SIGNAL_FUNC(new_window_cb), mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "net_state",
		       GTK_SIGNAL_FUNC(net_state_change_cb), mozzie);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "net_state_all",
		       GTK_SIGNAL_FUNC(net_state_change_all_cb), mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "progress",
		       GTK_SIGNAL_FUNC(progress_change_cb), mozzie);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "progress_all",
		       GTK_SIGNAL_FUNC(progress_change_all_cb), mozzie);
    
   
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "js_status",
		       GTK_SIGNAL_FUNC(js_status_cb), mozzie);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "visibility",
		       GTK_SIGNAL_FUNC(visibility_cb), mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed),
		       "destroy_browser",
		       GTK_SIGNAL_FUNC(destroy_brsr_cb), mozzie);
  
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "open_uri",
		       GTK_SIGNAL_FUNC(open_uri_cb), mozzie);
  
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "size_to",
		       GTK_SIGNAL_FUNC(size_to_cb), mozzie);

    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed), "dom_key_press",
		       GTK_SIGNAL_FUNC(on_key_press), mozzie);
    gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed),
		       "dom_mouse_click", GTK_SIGNAL_FUNC(on_mouse_click),
		       mozzie);
	window_set_selection_signals (mozzie);
}

void titlenote(geckobrowser *mozzie)
{
 gchar *legio = NULL;
	
	if(strcmp(mozilla_get_document_title(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed)),"")==0)
	 {
	  
	  gtk_label_set_text(GTK_LABEL(mozzie->gd->notelabel),"Document");
	  return;
	 }
	 else
	 {
      g_print("legio3");
	  mozzie->gd->webnote = mozilla_get_document_title(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed));
      legio=misc_string_shorten_name (mozzie->gd->webnote, 20);
      g_print("legion: %s",legio);
      gtk_label_set_text(GTK_LABEL(mozzie->gd->notelabel),legio);
     }
	 return;
 }

void titulo(geckobrowser *mozzie)
{
	gchar *aux;
	
 	if(num_embeds == -1)
	 return;
	
	aux=g_strconcat ("Salamander: ", mozilla_get_document_title (GTK_MOZ_EMBED(mozzie->gd->geckoEmbed)),NULL);
	gtk_window_set_title(GTK_WINDOW(mozzie->window), aux); 
    return;
}

void urlbar(geckobrowser *mozzie)
{
  
  mozzie->gd->geckourl = gtk_moz_embed_get_location(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed));
  gtk_editable_delete_text(GTK_EDITABLE(mozzie->urlEntry), 0, -1);
  gtk_entry_set_text(GTK_ENTRY(mozzie->urlEntry),mozzie->gd->geckourl);
}


static void on_notebook_switch_page(GtkNotebook * notebook,
				    GtkNotebookPage * page, guint page_num,geckobrowser *mozzie)
{
    gembed *hydra;
    GtkWidget *vbox=NULL;
     
     
    vbox = gtk_notebook_get_nth_page(GTK_NOTEBOOK(notebook), page_num);
	hydra = gtk_object_get_data(GTK_OBJECT(vbox), "SalamanderEmbed");
   
	if (hydra)
	{
	 mozzie->gd = hydra;
	 g_print("webtitle: %s\n\n",mozzie->gd->webtitle);
	 titulo(mozzie);
	 titlenote(mozzie);
	 urlbar(mozzie);
	 gtk_widget_grab_focus(GTK_BIN(mozzie->gd->geckoEmbed)->child);
	 gtk_widget_set_sensitive(mozzie->tback, TRUE);
	 gtk_widget_set_sensitive(mozzie->tforward, TRUE);
     g_print("hydraactvi");
	}
   return;
}

void create_notebook(geckobrowser * mozzie)
{
    mozzie->notebook = NULL;
    mozzie->notebook = gtk_notebook_new();
    /*gtk_notebook_set_tab_border(GTK_NOTEBOOK(mozzie->notebook), 6); */
    gtk_notebook_set_tab_hborder(GTK_NOTEBOOK(mozzie->notebook), 0);
    gtk_notebook_set_tab_vborder(GTK_NOTEBOOK(mozzie->notebook), 0);
    gtk_notebook_set_scrollable(GTK_NOTEBOOK(mozzie->notebook), TRUE);
    gtk_box_pack_start(GTK_BOX(mozzie->vbox), mozzie->notebook, TRUE,	// expand
		       TRUE,	// fill
		       0);
    gtk_notebook_set_show_border(GTK_NOTEBOOK(mozzie->notebook), FALSE);
	create_container(mozzie);
    gtk_signal_connect_after(GTK_OBJECT(mozzie->notebook), "switch_page",
		       GTK_SIGNAL_FUNC(on_notebook_switch_page), mozzie);
}

geckobrowser *create_mozilla(guint32 chromeMask)
{
    GtkStyle *xnew;
    GtkStyle *current;
    GtkStyle *new2;
    guint32 actualChromeMask;
    geckobrowser *mozzie = 0;


    mozzie = g_new0(geckobrowser, 1);
    mozzie->menuBarOn = FALSE;
    mozzie->toolBarOn = FALSE;
    mozzie->locationBarOn = FALSE;
    mozzie->statusBarOn = FALSE;
  
	num_browsers++;
    g_print("new_gtk_browser\n");
    actualChromeMask = chromeMask;

    if (chromeMask == GTK_MOZ_EMBED_FLAG_DEFAULTCHROME)
	actualChromeMask = GTK_MOZ_EMBED_FLAG_ALLCHROME;

    if (actualChromeMask & GTK_MOZ_EMBED_FLAG_MENUBARON) {
	mozzie->menuBarOn = TRUE;
	g_print("\tmenu bar\n");
    }
    if (actualChromeMask & GTK_MOZ_EMBED_FLAG_TOOLBARON) {
	mozzie->toolBarOn = TRUE;
	g_print("\ttool bar\n");
    }
    if (actualChromeMask & GTK_MOZ_EMBED_FLAG_LOCATIONBARON) {
	mozzie->locationBarOn = TRUE;
	g_print("\tlocation bar\n");
    }
    if (actualChromeMask & GTK_MOZ_EMBED_FLAG_STATUSBARON) {
	mozzie->statusBarOn = TRUE;
	g_print("\tstatus bar\n");
    }
    mozzie->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   /* gnome_window_icon_set_from_file(GTK_WINDOW(mozzie->window),
				    "/usr/share/salamander/gfx/salamander.png");*/
    gtk_window_set_title(GTK_WINDOW(mozzie->window),
			 "Salamander 0.5 based on Gecko");
    gtk_window_set_wmclass(GTK_WINDOW(mozzie->window), "Salamander",
			   "salamander_browser");
    gtk_signal_connect(GTK_OBJECT(mozzie->window), "delete_event",
		       GTK_SIGNAL_FUNC(delete_cb), mozzie);
    gtk_widget_realize(mozzie->window);
    mozzie->accelgroup = gtk_accel_group_new();
    gtk_window_add_accel_group(GTK_WINDOW(mozzie->window),
			       mozzie->accelgroup);
    mozzie->vbox = gtk_vbox_new(FALSE, 0);
    // add it to the toplevel window
	gtk_container_add(GTK_CONTAINER(mozzie->window), mozzie->vbox);
	if(vsourcef==0)
	{
	 create_menu(mozzie);
     create_toolbar(mozzie);
    }
    create_notebook(mozzie);
    mozzie->progressAreaHBox = gtk_hbox_new(FALSE, 0);
    // add it to the vbox
    gtk_box_pack_start(GTK_BOX(mozzie->vbox), mozzie->progressAreaHBox, FALSE,	// expand
		       FALSE,	// fill
		       0);	// padding
    // create our new progress bar
    mozzie->progressBar = gtk_progress_bar_new();
    // add it to the hbox
    gtk_box_pack_start(GTK_BOX(mozzie->progressAreaHBox), mozzie->progressBar, FALSE,	// expand
		       FALSE,	// fill
		       0);	// padding

    // create our status area and the alignment object that will keep it
    // from expanding
    mozzie->statusAlign = gtk_alignment_new(0, 0, 1, 1);
    gtk_widget_set_usize(mozzie->statusAlign, 1, -1); 
    // create the status bar
    mozzie->statusBar = gtk_statusbar_new();
	gtk_container_add(GTK_CONTAINER(mozzie->statusAlign), mozzie->statusBar);
    // add it to the hbox
    gtk_box_pack_start(GTK_BOX(mozzie->progressAreaHBox), mozzie->statusAlign, TRUE,	// expand
		       TRUE,	// fill
		       0);	// padding

    browser_list = g_list_append(browser_list, (gpointer) mozzie);
    gtk_moz_embed_set_chrome_mask(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
				  actualChromeMask);
    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    new2 = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    xnew->bg[GTK_STATE_PRELIGHT] = mozilla;
    gtk_widget_set_style(mozzie->notebook, xnew);
    gtk_widget_set_style(mozzie->window, xnew);
    gtk_widget_set_style(mozzie->progressBar, xnew);
    /* so widgets can look the data up */
    gtk_object_set_data(GTK_OBJECT(mozzie->window), "SalamanderWindow",
			mozzie);
  
    return mozzie;
}

static void salamander_init_mozembed(void)
{
    gchar *profile;

    profile = g_strconcat(home, "/.salamander/mozilla", NULL);
    gtk_moz_embed_set_profile_path(profile, "salamander");
    g_free(profile);
    gtk_moz_embed_push_startup();
	mozilla_init();
    return;
}

int main(int argc, char **argv)
{
    GtkMozEmbedSingle *single;

    if (!getenv("MOZILLA_FIVE_HOME")) {	/* avoid mozilla's components crashing */
	g_print(_
		("MOZILLA_FIVE_HOME is not set !, bailing out .. set it like this\nexport MOZILLA_FIVE_HOME=/path/to/mozilla \nthen retry.\n"));
	return 0;
    }
    read_bookmarks();
    gtk_set_locale();
    gnome_program_init ("Salamander", "0.5", LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, "",
                      NULL);
    gtk_init(&argc, &argv);
    home = g_get_home_dir();
    salamander_init_mozembed();

    /*splash();*/
    /*offline (); */

    browser_list = g_list_alloc();
    mozzie = create_mozilla(GTK_MOZ_EMBED_FLAG_DEFAULTCHROME);
    gtk_widget_set_usize(mozzie->gd->geckoEmbed, 750, 500);
    set_browser_visibility(mozzie, TRUE);

    if (argc > 1)
	gtk_moz_embed_load_url(GTK_MOZ_EMBED
			       (mozzie->gd->geckoEmbed), argv[1]);
    else
	gtk_moz_embed_load_url(GTK_MOZ_EMBED
			       (mozzie->gd->geckoEmbed),
			       "/usr/share/doc/HTML/index.html");
    single = gtk_moz_embed_single_get();
    if (!single) {
	fprintf(stderr, "Failed to get singleton embed object!\n");
	exit(1);
    }

   gtk_signal_connect(GTK_OBJECT(single), "new_window_orphan",
		       GTK_SIGNAL_FUNC(new_window_cb), NULL);
    analyzenet();
    mozzie->signal = 1;
    
    mozzie->gd->docurl = "Document";
	
	gtk_main();
    return 0;
}
