
/*Main.h for salamander*/


#include <stdio.h>
#include <mozilla-1.4b/gtkembedmoz/gtkmozembed.h>
#include <gtk-2.0/gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <libgnomeui-2.0/gnome.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
/*#include "print.h"*/

typedef struct _gembed gembed;
typedef struct _PrintDialog PrintDialog;	

	
struct _gembed {
	 GtkWidget  *geckoEmbed;
	 GtkWidget  *geckobox;
	 GtkWidget  *geckobutton;
	 gchar      *geckourl;
	 gchar *docurl;
	 gchar *webtitle;
	 gchar *webnote;
     gchar *locwebtitle;
	 gchar *locwebnote;
	 GtkWidget  *notelabel;
};
  	
	
typedef struct geckobrowser {
  GtkWidget  *window;
  GtkWidget *aux;
  GtkWidget  *vbox;
  GtkWidget  *hbox;
  GtkWidget  *menubar;
  GtkWidget  *notebook;
  GtkWidget  *popupmenu;
  GtkWidget  *fileMenuItem;
  GtkWidget  *fileMenu;
  GtkWidget  *fileOpenNewBrowser;
  GtkWidget  *fileOpenNewTab;
  GtkWidget  *fileOpen;
  GtkWidget  *fileopendialog;
  GtkWidget  *fileSaveas;
  GtkWidget  *filesavedialog;
  GtkWidget  *imagesavedialog;
  GtkWidget  *filePrint;
  GtkWidget  *fileClose;
  GtkWidget  *fileCloseTab;
  GtkWidget  *fileQuit;
  GtkWidget  *editMenuItem;
  GtkWidget  *editMenu;
  GtkWidget  *editPaste;
  GtkWidget  *editCopy;
  GtkWidget  *editSelect;
  GtkWidget  *editFind;
  GtkWidget  *coolMenu;
  GtkWidget  *coolMenuItem;
  GtkWidget  *coolAdd;
  GtkWidget  *coolEdit;
  GtkWidget  *viewMenuItem;
  GtkWidget  *viewMenu;
  GtkWidget  *viewSource;
  GtkWidget  *viewZoom;
  GtkWidget  *viewZoommenu;
  GtkWidget  *zoomin;
  GtkWidget  *zoomout;
  GtkWidget  *zoom100;
  GtkWidget  *helpMenu;
  GtkWidget  *helpMenuItem;
  GtkWidget  *helpAbout;
  GtkWidget  *helpPlugins;
  GtkWidget  *helpDev;
  GtkWidget  *toolbarhbox;
  GtkWidget  *toolbar;
  GtkWidget  *dock;
  GtkWidget  *urlEntry;
  GtkWidget  *url_gnomeentry;
  GtkWidget  *progressAreaHBox;
  GtkWidget  *progressBar;
  GtkWidget  *statusAlign;
  GtkWidget  *statusBar;
  const char *statusMessage;
  int         loadPercent;
  int         bytesLoaded;
  int         maxBytesLoaded;
  int         signal;
  char       *tempMessage;
  gint        zoom;
  GtkWidget  *button;
  GtkWidget  *pixw;
  GtkWidget  *tback;
  GtkWidget  *tforward;
  GtkWidget  *tstop;
  GtkWidget  *thome;
  GtkWidget  *treload;
  GtkWidget  *tgoogle;
  GtkWidget  *all;
  GtkWidget  *animator;
  gboolean menuBarOn;
  gboolean toolBarOn;
  gboolean locationBarOn;
  gboolean statusBarOn;
  gboolean didFind;
  gchar *url;
  gchar *location;
  gchar *uri;
  gint type;
  GtkAccelGroup *accelgroup;
  GtkWidget *reload_menu; /* context menu for reload flags */
  GtkWidget *doc_menu; /* pointer to document popup menu */
  GtkWidget *image_menu; /* pointer to image popup menu */
  GtkWidget *link_menu; /* pointer to link popup menu */
  GtkWidget *image_link_menu; /* pointer to image link popup menu */
  PrintDialog *pd;
  gembed *gd;
} geckobrowser;

geckobrowser *mozzie;

typedef struct {
	gchar *label;
	gchar *url;
	gint pos; /* 0 - menu; 1 - toolbar */
}
BookmarkData;

typedef struct {
	GtkWidget *window;
	GtkWidget *clist;
	GtkWidget *text_entry;
	GtkWidget *url_entry;
	GtkWidget *menu_radio_button;
	GtkWidget *toolbar_radio_button;
}
BookmarkWindow;

struct _PrintDialog
{
	GtkWidget *window;
	GtkWidget *PrintToPrinterRb;
     	GtkWidget *PrintToFileRb;
     	GtkWidget *PrintCommand;
     	GtkWidget *FileName;
     	GtkWidget *FirstPageFirst;
     	GtkWidget *LastPageFirst;
     	GtkWidget *Color;
     	GtkWidget *GreyScale;
     	GtkWidget *Letter;
     	GtkWidget *Legal;
     	GtkWidget *A4;
     	GtkWidget *Executive;
     	GtkWidget *AllPages;
     	GtkWidget *Pages;
     	GtkWidget *From;
     	GtkWidget *To;
     	GtkWidget *TopMargin;
     	GtkWidget *LeftMargin;
     	GtkWidget *RightMargin;
     	GtkWidget *BottomMargin;     
};



geckobrowser *create_mozilla(guint32 chromeMask);
void   set_browser_visibility (geckobrowser *mozzie,
					       gboolean visibility);
void load(GtkWidget * widget, geckobrowser * mozzie);
void splash();
void create_menu(geckobrowser *mozzie);
void create_toolbar(geckobrowser *mozzie);
void menu_quit_cb (GtkMenuItem *menuitem, geckobrowser *mozzie);
void menu_open_new_cb   (GtkMenuItem *menuitem, geckobrowser *mozzie);
void menu_saveas_cb   (GtkMenuItem *menuitem, geckobrowser *mozzie);
void destroy_brsr_cb(GtkMozEmbed *embed,geckobrowser *mozzie);

void update_status_bar_text(geckobrowser *mozzie);
void update_temp_message(geckobrowser *mozzie, const char *message);
void update_nav_buttons(geckobrowser *mozzie);
void location_changed_cb (GtkMozEmbed *embed, geckobrowser *mozzie);
void title_changed_cb    (GtkMozEmbed *embed, geckobrowser *mozzie);
void load_started_cb     (GtkMozEmbed *embed,geckobrowser *mozzie);
void load_finished_cb (GtkMozEmbed *embed, geckobrowser *mozzie);
void net_state_change_cb (GtkMozEmbed *embed, gint flags, guint status,
		     geckobrowser *mozzie);
void net_state_change_all_cb (GtkMozEmbed *embed, const char *uri,
				     gint flags, guint status,
				     geckobrowser *mozzie);
void progress_change_cb   (GtkMozEmbed *embed, gint cur, gint max,
			   geckobrowser *mozzie);
void progress_change_all_cb (GtkMozEmbed *embed, const char *uri,
			     gint cur, gint max,
			     geckobrowser *mozzie);
void link_message_cb(GtkMozEmbed *embed,geckobrowser *mozzie);
void js_status_cb (GtkMozEmbed *embed, geckobrowser *mozzie);
void new_window_cb (GtkMozEmbed *embed, GtkMozEmbed **newEmbed, guint chromemask,geckobrowser *mozzie);
void visibility_cb (GtkMozEmbed *embed, gboolean visibility,geckobrowser *mozzie);
gint open_uri_cb(GtkMozEmbed *embed, const char *uri,geckobrowser *mozzie);
void size_to_cb (GtkMozEmbed *embed, gint width, gint height,
	    geckobrowser *mozzie);
void menu_open_new_tab(GtkMenuItem * menuitem, geckobrowser * mozzie);		

void read_bookmarks();
void showpopup(geckobrowser *mozzie,int button);
void addcoolsite(GtkWidget *menuitem,geckobrowser *mozzie);
void bookmark_activate(GtkWidget *widget,geckobrowser *mozzie);
void edit_bookmarks(GtkWidget *menuitem,gpointer user_data);
void on_bookmark_clist_select_row(GtkWidget *clist,gint row,gint col,GdkEventButton *event,BookmarkWindow *bwin);
void on_bookmark_clist_unselect_row(GtkWidget *clist,gint row,gint col,GdkEventButton *event,BookmarkWindow *bwin);
void on_bookmark_menu_radio_button_toggled(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_toolbar_radio_button_toggled(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_add_button_clicked(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_update_button_clicked(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_remove_button_clicked(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_cancel_button_clicked(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_ok_button_clicked(GtkWidget *button,BookmarkWindow *bwin);
void on_bookmark_delete_event(GtkWidget *widget,GdkEvent *event,BookmarkWindow *bwin);
void close_bookmark_window(BookmarkWindow *bwin);
gint on_key_press(GtkMozEmbed *embed, gpointer dom_event,geckobrowser *mozzie);
gint on_mouse_click(GtkMozEmbed *embed, gpointer dom_event,geckobrowser *mozzie);
/*extern gint dom_key_down_cb(GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);*/
extern gint dom_key_press_cb(gpointer event);/*
extern gint dom_key_up_cb        (GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);
extern gint dom_mouse_down_cb    (GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);
extern gint dom_mouse_up_cb      (GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);*/
extern gint dom_mouse_click_cb   (gpointer dom_event);/*
extern gint dom_mouse_dbl_click_cb (GtkMozEmbed *embed,gpointer dom_event,
			     geckobrowser *mozzie);
extern gint dom_mouse_over_cb    (GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);
extern gint dom_mouse_out_cb     (GtkMozEmbed *embed, gpointer dom_event,
			   geckobrowser *mozzie);*/
			   
extern gboolean mozilla_find(GtkMozEmbed *b, const gchar *exp, gboolean matchcase, gboolean search_backwards, gboolean search_wrap_around, gboolean search_for_entire_word, gboolean search_in_frames, gboolean found);
extern gboolean mozilla_copy_selection (GtkMozEmbed *embed);
extern gboolean mozilla_save_document (GtkMozEmbed *embed, char *filename,
					   const char *datapath, int action,
					   gboolean mainDoc);
extern gboolean mozilla_save_link (GtkMozEmbed *embed, const char *url);
extern gboolean mozilla_save_url (GtkMozEmbed *embed, const char *url, 
				      char *file_name, int action);
extern gchar *mozilla_get_document_url (GtkMozEmbed *embed);
extern gchar *mozilla_get_main_document_url(GtkMozEmbed *embed);
extern gboolean mozilla_preference_set_int(const char	*preference_name,    gint  new_int_value);
extern gboolean mozilla_preference_set (const char *preference_name, const char *new_value);
extern gboolean mozilla_set_offline (gboolean offline);
extern gboolean mozilla_paste_selection (GtkMozEmbed * embed);
extern void mozilla_save_image (GtkMozEmbed * b, gchar * location, gchar * FullPath);
extern gboolean mozilla_save (GtkMozEmbed * embed, gchar * file_name, gint all);
extern glong mozilla_get_context_menu_type (GtkMozEmbed * b, gpointer event, gchar ** img,
			       gchar ** link, gchar ** linktext);
extern gboolean mozilla_set_zoom (GtkMozEmbed *embed, float f);
extern gboolean mozilla_get_zoom (GtkMozEmbed *embed, float *f);
extern gchar * mozilla_get_document_title (GtkMozEmbed *embed);
extern void mozilla_select_all (GtkMozEmbed *embed);
extern void mozilla_init();

void image_save(geckobrowser *mozzie);
void create_book_menu (geckobrowser * mozzie);

GtkWidget * get_link_image_popup_menu(geckobrowser *mozzie, gchar *img, gchar *href);
GtkWidget * get_doc_popup_menu(geckobrowser *mozzie, gchar *href);
GtkWidget * get_image_popup_menu(geckobrowser *mozzie, gchar *img);
GtkWidget * get_link_popup_menu(geckobrowser *mozzie, gchar *href, gchar *linktext);
void savefile(GtkWidget *widget,geckobrowser *mozzie);
void printfile(geckobrowser *mozzie);
void surprise2(geckobrowser *mozzie);
void surprise(geckobrowser *mozzie);
void surprise3 (geckobrowser *mozzie);
void save_image (geckobrowser * mozzie, gchar * image_link, gchar * image_name);
void back_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void stop_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void forward_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void reload_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void home_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void google_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void slashdot_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void mandrake_clicked_cb (GtkButton * button, geckobrowser * mozzie);
void ymail_clicked_cb (GtkButton * button, geckobrowser * mozzie);
gembed *get_current_browser_from_notebook(geckobrowser *mozzie);
gembed *get_current_title_from_notebook(geckobrowser *mozzie);
void hydraload(GtkWidget *widget ,geckobrowser * mozzie);
void update_tab_size(geckobrowser *mozzie);
gboolean download_url (geckobrowser * mozzie, const gchar * uri);
gboolean download_url2 (geckobrowser * mozzie, const gchar * uri);
void
window_set_selection_signals (geckobrowser *mozzie);
void linkbook(GtkWidget *menuitem,geckobrowser *mozzie);
void create_notebook(geckobrowser * mozzie);
static GdkColor mozilla = { 0, 0xDEDE, 0xE2E2, 0xEEEE };
void titlenote(geckobrowser *mozzie);
int loadentry;
int loadembed;
static int popupwin=0;
static int vsourcef=0;
char *base;
