
#include"main.h"


#define CONTEXT_NONE     0
#define CONTEXT_DEFAULT  1
#define CONTEXT_LINK     2
#define CONTEXT_IMAGE    4
#define CONTEXT_DOCUMENT 8
#define CONTEXT_INPUT    64
#define CONTEXT_OTHER    128
#define CONTEXT_XUL      256


gint
on_mouse_click(GtkMozEmbed * embed,gpointer dom_event,
	       geckobrowser * mozzie)
{
    gint button;
    glong type;
    gchar *img = NULL, *href = NULL, *linktext = NULL;

    type = mozilla_get_context_menu_type(embed, dom_event, &img, &href,
					 &linktext);
    button = dom_mouse_click_cb(dom_event);
   
	
    if (button >0) {
		
	if ((type & CONTEXT_IMAGE) && (type & CONTEXT_LINK)) {
	    gtk_menu_popup(GTK_MENU
			   (get_link_image_popup_menu
			    (mozzie, img, href)), NULL, NULL,
			   NULL, NULL, GDK_3BUTTON_PRESS, gtk_get_current_event_time());
	} else if (type & CONTEXT_IMAGE) {
	    gtk_menu_popup(GTK_MENU
			   (get_image_popup_menu(mozzie, img)),
			   NULL, NULL, NULL, NULL, GDK_3BUTTON_PRESS, gtk_get_current_event_time());
	} else if (type & CONTEXT_LINK) {
	    gtk_menu_popup(GTK_MENU
			   (get_link_popup_menu
			    (mozzie, href, linktext)), NULL,
			   NULL, NULL, NULL, GDK_3BUTTON_PRESS, gtk_get_current_event_time());
	} else if (type & CONTEXT_DOCUMENT) {
	    gtk_menu_popup(GTK_MENU
			   (get_doc_popup_menu(mozzie, href)),
			   NULL, NULL, NULL, NULL, GDK_3BUTTON_PRESS, gtk_get_current_event_time());
	} else if (type & CONTEXT_OTHER) {
	    g_print(_("clicked on some other components\n"));
	}
	return TRUE;
    }
	else
	 g_print("boton 0 hell");
    return FALSE;
}

gint
on_key_press(GtkMozEmbed * embed, gpointer dom_event,
	     geckobrowser * mozzie)
{
    long key;
    /*key = dom_key_press_cb(dom_event); */
    return 0;
}

void update_status_bar_text(geckobrowser * mozzie)
{
    gchar message[256];


    gtk_statusbar_pop(GTK_STATUSBAR(mozzie->statusBar), 1);
    if (mozzie->tempMessage)
	gtk_statusbar_push(GTK_STATUSBAR(mozzie->statusBar), 1,
			   mozzie->tempMessage);
    else {
	if (mozzie->loadPercent) {
	    g_snprintf(message, 255,
		       "%s (%d%% complete, %d bytes of %d loaded)",
		       mozzie->statusMessage,
		       mozzie->loadPercent, mozzie->bytesLoaded,
		       mozzie->maxBytesLoaded);
	} else if (mozzie->bytesLoaded) {
	    g_snprintf(message, 255, "%s (%d bytes loaded)",
		       mozzie->statusMessage, mozzie->bytesLoaded);
	} else if (mozzie->statusMessage == NULL) {
	    g_snprintf(message, 255, " ");
	} else {
	    g_snprintf(message, 255, "%s", mozzie->statusMessage);
	}
	gtk_statusbar_push(GTK_STATUSBAR(mozzie->statusBar), 1, message);
    }
}

void update_temp_message(geckobrowser * mozzie, const char *message)
{
    if (mozzie->tempMessage)
	g_free(mozzie->tempMessage);
    if (message)
	mozzie->tempMessage = g_strdup(message);
    else
	mozzie->tempMessage = 0;
    /*now that we've updated the temp message, redraw the status bar */
    update_status_bar_text(mozzie);
}

void update_nav_buttons(geckobrowser * mozzie)
{
    gboolean can_go_back;
    gboolean can_go_forward;
    can_go_back =
	gtk_moz_embed_can_go_back(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed));
    can_go_forward =
	gtk_moz_embed_can_go_forward(GTK_MOZ_EMBED
				     (mozzie->gd->geckoEmbed));
    if (can_go_back)
	gtk_widget_set_sensitive(mozzie->tback, TRUE);
    else
	gtk_widget_set_sensitive(mozzie->tback, FALSE);
    if (can_go_forward)
	gtk_widget_set_sensitive(mozzie->tforward, TRUE);
    else
	gtk_widget_set_sensitive(mozzie->tforward, FALSE);
}



void location_changed_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{
    char *newLocation;
    int newPosition = 0;
    g_print("location_changed_cb\n");
    newLocation = gtk_moz_embed_get_location(embed);
    if (newLocation) {
	gtk_editable_delete_text(GTK_EDITABLE(mozzie->urlEntry), 0, -1);
	gtk_editable_insert_text(GTK_EDITABLE(mozzie->urlEntry),
				 newLocation, strlen(newLocation),
				 &newPosition);
	g_free(newLocation);
    } else
	g_print("failed to get location!\n");
    /*always make sure to clear the tempMessage.  it might have been
       set from the link before a click and we wouldn't have gotten the
       callback to unset it. */
    update_temp_message(mozzie, 0);
    update_nav_buttons(mozzie);
}

void title_changed_cb(GtkMozEmbed * embed, geckobrowser *mozzie)
{
	gchar *aux;
	
	
    aux = g_strconcat ("Salamander: ", mozilla_get_document_title (embed),NULL);
	titlenote(mozzie);
	gtk_window_set_title(GTK_WINDOW(mozzie->window), aux); 
	g_free(aux); 
}

void load_started_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{


    g_print("load_started_cb\n");
    gtk_widget_set_sensitive(mozzie->tstop, TRUE);
    mozzie->loadPercent = 0;
    mozzie->bytesLoaded = 0;
    mozzie->maxBytesLoaded = 0;
    update_status_bar_text(mozzie);
}

void load_finished_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{
	
	
    g_print("load_finished_cb\n");
    gtk_widget_set_sensitive(mozzie->tstop, FALSE);
    mozzie->loadPercent = 0;
    mozzie->bytesLoaded = 0;
    mozzie->maxBytesLoaded = 0;
    update_status_bar_text(mozzie);
    gtk_progress_set_percentage(GTK_PROGRESS(mozzie->progressBar), 0);

    update_tab_size(mozzie);
	mozzie->uri = gtk_moz_embed_get_title(embed);
	g_print("webtitle2: %s\n\n",mozzie->uri);
	if(strcmp(mozzie->uri,"")==0)
	 return;
	else
	 gtk_label_set_text(GTK_LABEL(mozzie->gd->notelabel), mozzie->uri);
}

void
net_state_change_cb(GtkMozEmbed * embed, gint flags, guint status,
		    geckobrowser * mozzie)
{
    g_print("net_state_change_cb %d\n", flags);
    if (flags & GTK_MOZ_EMBED_FLAG_IS_REQUEST) {
	if (flags & GTK_MOZ_EMBED_FLAG_REDIRECTING)
	    mozzie->statusMessage = "Redirecting to site...";
	else if (flags & GTK_MOZ_EMBED_FLAG_TRANSFERRING)
	    mozzie->statusMessage = "Transferring data from site...";
	else if (flags & GTK_MOZ_EMBED_FLAG_NEGOTIATING)
	    mozzie->statusMessage = "Waiting for authorization...";
    }

    if (status == GTK_MOZ_EMBED_STATUS_FAILED_DNS)
	mozzie->statusMessage = "Site not found.";
    else if (status == GTK_MOZ_EMBED_STATUS_FAILED_CONNECT)
	mozzie->statusMessage = "Failed to connect to site.";
    else if (status == GTK_MOZ_EMBED_STATUS_FAILED_TIMEOUT)
	mozzie->statusMessage = "Failed due to connection timeout.";
    else if (status == GTK_MOZ_EMBED_STATUS_FAILED_USERCANCELED)
	mozzie->statusMessage = "User canceled connecting to site.";

    if (flags & GTK_MOZ_EMBED_FLAG_IS_DOCUMENT) {
	if (flags & GTK_MOZ_EMBED_FLAG_START)
	    mozzie->statusMessage = "Loading site...";
	else if (flags & GTK_MOZ_EMBED_FLAG_STOP)
	    mozzie->statusMessage = "Done.";
    }

    update_status_bar_text(mozzie);

}

void
net_state_change_all_cb(GtkMozEmbed * embed, const char *uri,
			gint flags, guint status, geckobrowser * mozzie)
{

}

void
progress_change_cb(GtkMozEmbed * embed, gint cur, gint max,
		   geckobrowser * mozzie)
{
    g_print("progress_change_cb cur %d max %d\n", cur, max);

    // avoid those pesky divide by zero errors
    if (max < 1) {
	gtk_progress_set_activity_mode(GTK_PROGRESS
				       (mozzie->progressBar), FALSE);
	mozzie->loadPercent = 0;
	mozzie->bytesLoaded = cur;
	mozzie->maxBytesLoaded = 0;
	update_status_bar_text(mozzie);
    } else {
	mozzie->bytesLoaded = cur;
	mozzie->maxBytesLoaded = max;
	if (cur > max)
	    mozzie->loadPercent = 100;
	else
	    mozzie->loadPercent = (cur * 100) / max;
	update_status_bar_text(mozzie);
	gtk_progress_set_percentage(GTK_PROGRESS
				    (mozzie->progressBar),
				    mozzie->loadPercent / 100.0);
    }

}

void
progress_change_all_cb(GtkMozEmbed * embed, const char *uri,
		       gint cur, gint max, geckobrowser * mozzie)
{

}

void link_message_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{
    char *message;
    g_print("link_message_cb\n");
    message = gtk_moz_embed_get_link_message(embed);
    g_print(message);
    if (message && (strlen(message) == 0))
	update_temp_message(mozzie, 0);
    else
	update_temp_message(mozzie, message);
    if (message)
	g_free(message);
}

void js_status_cb(GtkMozEmbed * embed, geckobrowser * mozzie)
{
    char *message;
    g_print("js_status_cb\n");
    message = gtk_moz_embed_get_js_status(embed);
    if (message && (strlen(message) == 0))
	update_temp_message(mozzie, 0);
    else
	update_temp_message(mozzie, message);
    if (message)
	g_free(message);
}

void
new_window_cb(GtkMozEmbed * embed, GtkMozEmbed ** newEmbed,
	      guint chromemask, geckobrowser * mozzie)
{
	geckobrowser *newBrowser;

	popupwin=1;
    newBrowser = create_mozilla(chromemask);
    g_print("new_window_cb\n");
    g_print("embed is %p chromemask is %d\n", (void *) embed, chromemask);
    //gtk_widget_set_usize(newBrowser->gd->geckoEmbed, 400, 400);
    *newEmbed = GTK_MOZ_EMBED(newBrowser->gd->geckoEmbed);
    g_print("new browser is %p\n", (void *) *newEmbed);
	popupwin=0;
}


void
visibility_cb(GtkMozEmbed * embed, gboolean visibility,
	      geckobrowser * mozzie)
{
    g_print("visibility_cb %d\n", visibility);
    set_browser_visibility(mozzie, visibility);
}

gint
open_uri_cb(GtkMozEmbed * embed, const char *uri, geckobrowser * mozzie)
{
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra) {
	  mozzie->gd = hydra;
	g_print("Activado!");
    }
    g_print ("open_uri_cb %s\n", uri); 
    loadembed = 1;
    loadentry = 0;
    update_tab_size(mozzie);
	
    if (!strcmp(uri, "http://people.redhat.com/blizzard/monkeys.txt"))
	 return TRUE;
	return FALSE;

}

void
size_to_cb(GtkMozEmbed * embed, gint width, gint height,
	   geckobrowser * mozzie)
{
    g_print("*** size_to_cb %d %d\n", width, height);
    gtk_widget_set_usize(mozzie->gd->geckoEmbed, width, height);
}
