/* Copyright (c) 2003 - Charles Schmidt <cschmidt2@emich.edu> */

#ifndef __SAL_MOZILLA_H__
#define __SAL_MOZILLA_H__

#include <glib/gtypes.h>

#define MOZILLA_NONE 0
#define MOZILLA_CONTEXT_DEFAULT  1
#define MOZILLA_CONTEXT_LINK     2
#define MOZILLA_CONTEXT_IMAGE    4
#define MOZILLA_CONTEXT_DOCUMENT 8
#define MOZILLA_CONTEXT_INPUT    64
#define MOZILLA_CONTEXT_OTHER    128
#define MOZILLA_CONTEXT_XUL      256

#define MOZILLA_MODIFIER_ALT 1
#define MOZILLA_MODIFIER_CTRL 2
#define MOZILLA_MODIFIER_SHIFT 4
#define MOZILLA_MODIFIER_META 8

#define MOZILLA_KEY_LEFT 37
#define MOZILLA_KEY_RIGHT 39
#define MOZILLA_KEY_ESC 27

extern gboolean mozilla_init(void);

extern gboolean mozilla_find(gpointer moz_embed,const gchar *text,gint direction,gboolean wrap,gboolean match_case);

extern gint mozilla_dom_event_get_button(gpointer dom_event);
extern gint mozilla_dom_event_get_context_menu_type(gpointer dom_event,gchar **img,gchar **uri,gchar **link_text);
extern glong mozilla_dom_event_get_key(gpointer dom_event,glong *modifier);
extern gboolean mozilla_preferences_set_string(const gchar *key,const gchar *value);
extern gboolean mozilla_preferences_set_bool(const gchar *key,gboolean value);
extern gboolean mozilla_preferences_set_int(const gchar *key,gint value);
extern gboolean mozilla_preferences_finish(void);


#endif
